%{
/* rechpars.y
 * ===============================================================
 * Parser for lex/yacc-Based Calculator (95/04/28)
 * Copyright 1995: Martin Weitzel, Darmstadt
 * ===============================================================
*/
#include <stdio.h>

char HEXFMT[] = "= %#x\n";
char DECFMT[] = "= %d\n";
char OCTFMT[] = "= %#o\n";
char *ofmt = HEXFMT;	/* output format */

int vars[26];		/* user variables */

int result;

void showresult(r)
	int r;
{
	(void) printf(ofmt, result = r);
}

%}
%union {
	int constant;
	int *variable;
};
%token _hex_ _dec_ _oct_
%token <constant> CONST
%token <variable> VAR
%left '+' '-'
%left '*' '/' '%'
%right _UMINUS
%type <constant> expr

%%
input	:	/*empty*/
	|	input command '\n'
	|	error '\n'		{ yyerrok; }
	;
command	:	/*empty*/
	|	expr			{ showresult($1); }
	|	_hex_			{ ofmt = HEXFMT; }
	|	_dec_			{ ofmt = DECFMT; }
	|	_oct_			{ ofmt = OCTFMT; }
	|	VAR '=' expr		{ *$1 = $3; }
	;
expr	:	CONST			{ $$ = $1; }
	|	VAR			{ $$ = *$1; }
	|	'$'			{ $$ = result; }
	|	'-' expr %prec _UMINUS	{ $$ = - $2; }
	|	expr '+' expr		{ $$ = $1 + $3; }
	|	expr '-' expr		{ $$ = $1 - $3; }
	|	expr '*' expr		{ $$ = $1 * $3; }
	|	expr '/' expr		{ $$ = $1 / $3; }
	|	expr '%' expr		{ $$ = $1 % $3; }
	|	'(' expr ')'		{ $$ = $2; }
	;
%%
#include "lex.yy.c"
