%{
/* rechscan.l
 * ===============================================================
 * Scanner for lex/yacc-Based Calculator (95/04/28)
 * Copyright 1995: Martin Weitzel, Darmstadt
 * ===============================================================
*/
#include <ctype.h>
#include <stdlib.h>
%}
%%
[ \t]	;
hex	return _hex_;
dec	return _dec_;
oct 	return _oct_;
0[0-7]*	|
[0-9]+	|
0[xX][0-9a-fA-F]+ {
		yylval.constant =
			(int) strtol(yytext, (char **)0, 0);
		return CONST;
	}
[a-zA-Z] {
		yylval.variable =
			&vars[toupper(yytext[0]) - 'A'];
		return VAR;
	}
.|\n	return yytext[0];
%%
