/* wtab.c
 ==============================================================
 Implementation: Waehrungstabelle und Suchfunktion (95/05/02)
 ==============================================================
*/

#include "wtab.h"

#include <string.h>

WTAB wtab[] = {
	{ "DM"	}, 	/* Deutsche Mark */
	{ "FR"	}, 	/* Franzoesische Franc */
	{ "SFR"	},	/* Schweizer Franken */
	{ "USD"	},	/* US-Dollar */
	{ "PTS"	},	/* Spanische Peseten */
	{ "DR"	},	/* Griechische Drachmen */
	{ "DKR" },	/* Daenische Kronen */
	{ '\0' } /* <----- NEVER DELETE THIS ENTRY! */
};

WTAB *wtabfind(		/* -- Eintrag in Tabelle suchen */
	const char *wkz		/* Waehrungskennzeichen */
) {
	WTAB *p;
	for (p = wtab; p->wkz[0]; ++p) {
		if (!strcmp(p->wkz, wkz))
			return p;
	}
	return (WTAB *)0;
}
